##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE=0 1 3 4 6 9 10 11 12 13 15 17 18 20 25 26

## Default values
$(eval $(call IMG2SP, SET_MODE        , 0                   )) # { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
$(eval $(call IMG2SP, SET_FOLDER      , src/sprites/        ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites             ))#	{ sprites, zgtiles, screen }
$(eval $(call IMG2SP, SET_OUTPUT      , c                   )) # { bin, c }
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))

$(eval $(call IMG2SP, CONVERT         , assets/char1_D1.png ,    8, 18, sprite_char_D1    ))
$(eval $(call IMG2SP, CONVERT         , assets/char1_D2.png ,    8, 18, sprite_char_D2    ))
$(eval $(call IMG2SP, CONVERT         , assets/char1_L1.png ,    8, 18, sprite_char_L1    ))
$(eval $(call IMG2SP, CONVERT         , assets/char1_L2.png ,    8, 18, sprite_char_L2    ))
$(eval $(call IMG2SP, CONVERT         , assets/char1_R1.png ,    8, 18, sprite_char_R1    ))
$(eval $(call IMG2SP, CONVERT         , assets/char1_R2.png ,    8, 18, sprite_char_R2    ))
$(eval $(call IMG2SP, CONVERT         , assets/char1_U1.png ,    8, 18, sprite_char_U1    ))
$(eval $(call IMG2SP, CONVERT         , assets/char1_U2.png ,    8, 18, sprite_char_U2    ))
$(eval $(call IMG2SP, CONVERT         , assets/malo1-1.png  ,    8, 18, sprite_e1_1        ))
$(eval $(call IMG2SP, CONVERT         , assets/zombie2.png  ,    8, 18, sprite_e1_2        ))
$(eval $(call IMG2SP, CONVERT         , assets/malo2-1.png  ,    8, 15, sprite_e2_1        ))
$(eval $(call IMG2SP, CONVERT         , assets/fantasma2.png  ,  8, 15, sprite_e2_2        ))
$(eval $(call IMG2SP, CONVERT         , assets/zombieArcoiris.png  ,    8, 18, sprite_zombie_arcoiris     ))
$(eval $(call IMG2SP, CONVERT         , assets/zombieArcoiris2.png  ,    8, 18, sprite_zombie_arcoiris2     ))
$(eval $(call IMG2SP, CONVERT         , assets/decos/puerta_arr.png ,    4, 13, sprite_puerta_arr   ))
$(eval $(call IMG2SP, CONVERT         , assets/decos/puerta_abaj.png ,    4, 4, sprite_puerta_abaj  ))
$(eval $(call IMG2SP, CONVERT         , assets/decos/puerta_lateral.png , 4, 6, sprite_puerta_lat   ))
$(eval $(call IMG2SP, CONVERT         , assets/decos/puerta_lateral_der.png , 4, 6, sprite_puerta_lat_der   ))
$(eval $(call IMG2SP, CONVERT         , assets/decos/ventana.png , 30, 19, sprite_vent   ))
$(eval $(call IMG2SP, CONVERT         , assets/decos/ventana_abaj.png , 36, 4, sprite_vent_abaj   ))
$(eval $(call IMG2SP, CONVERT         , assets/decos/poster.png , 14, 16, sprite_poster   ))
$(eval $(call IMG2SP, CONVERT         , assets/decos/comida.png , 18, 33, sprite_comida   )) 
$(eval $(call IMG2SP, CONVERT         , assets/decos/poster_rounds.png , 20, 15, sprite_poster_rounds   )) 
$(eval $(call IMG2SP, CONVERT         , assets/spritecora.png , 8, 9, sprite_corazon   )) 
$(eval $(call IMG2SP, CONVERT         , assets/bat.png , 8, 14, sprite_murcielago   )) 
$(eval $(call IMG2SP, CONVERT         , assets/bat2.png , 8, 14, sprite_murcielago2   )) 
$(eval $(call IMG2SP, CONVERT         , assets/ovni.png , 8, 14, sprite_ovni   )) 
$(eval $(call IMG2SP, CONVERT         , assets/calabaza.png , 8, 14, sprite_calabaza   ))
$(eval $(call IMG2SP, CONVERT         , assets/calabaza2.png , 8, 14, sprite_calabaza_woke   )) 
$(eval $(call IMG2SP, CONVERT         , assets/esquele.png , 8, 14, sprite_esqueleto   )) 
$(eval $(call IMG2SP, CONVERT         , assets/calavera2.png , 8, 14, sprite_esqueleto2   )) 
$(eval $(call IMG2SP, CONVERT         , assets/arana.png , 8, 14, sprite_arana   )) 
$(eval $(call IMG2SP, CONVERT         , assets/arana2.png , 8, 14, sprite_arana2   )) 
$(eval $(call IMG2SP, CONVERT         , assets/burger.png , 8, 14, sprite_burger   )) 
$(eval $(call IMG2SP, CONVERT         , assets/explosion.png , 8, 18, sprite_explosion   )) 
$(eval $(call IMG2SP, CONVERT         , assets/explos2.png , 8, 18, sprite_explosion2   )) 
$(eval $(call IMG2SP, CONVERT         , assets/heart_expl1.png , 8, 18, sprite_explosion_rain   )) 
$(eval $(call IMG2SP, CONVERT         , assets/heart_expl2.png , 8, 18, sprite_explosion2_rain   ))

$(eval $(call IMG2SP, CONVERT         , assets/arma0.png , 72, 56, sprite_arma_0   )) 
$(eval $(call IMG2SP, CONVERT         , assets/arma1.png , 72, 56, sprite_arma_1   )) 
$(eval $(call IMG2SP, CONVERT         , assets/arma2.png , 72, 56, sprite_arma_2   )) 


$(eval $(call IMG2SP, SET_IMG_FORMAT  , screen             ))#	{ sprites, zgtiles, screen }
$(eval $(call IMG2SP, SET_FOLDER  , src/screens/             ))
$(eval $(call IMG2SP, SET_OUTPUT  , bin             ))
$(eval $(call IMG2SP, CONVERT  , assets/screens/pantallaCarga2.png, 0, 0, screen_menu             ))
$(eval $(call IMG2SP, CONVERT  , assets/screens/pantallacreditos.png, 0, 0, credits_screen             ))

#$(eval $(call IMG2SP, CONVERT         , assets/char2.png ,   12, 24, sprite_char2   ))
#$(eval $(call IMG2SP, CONVERT         , assets/malo1_0.png , 12, 24, sprite_malo1_0 ))
#$(eval $(call IMG2SP, CONVERT         , assets/malo1_1.png , 12, 24, sprite_malo1_1 ))
#$(eval $(call IMG2SP, CONVERT         , assets/malo2_0.png , 12, 24, sprite_malo2_0 ))
#$(eval $(call IMG2SP, CONVERT         , assets/malo2_1.png , 12, 24, sprite_malo2_1 ))

##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
